---
title: "迁移到 wayland 事记"
date: 2021-10-24T17:28:00+08:00
tags: [ linux, KVM ]
categories: [ tech ]
weight: 50
show_comments: true
draft: false
---

## 一些环境变量

设置了一些环境变量，如果不设置这些环境变量，那么有一部分程序会在启动时字体发毛，比如 `MOZ_ENABLE_WAYLAND` 能够避免 firefox 出现字体发毛。

```bash
export GDK_BACKEND=wayland      # GTK
export QT_QPA_PLATFORM=wayland  # QT
export CLUTTER_BACKEND=wayland  # Clutter
export SDL_VIDEODRIVER=wayland  # SDL
# mozilla wayland envionment
export MOZ_ENABLE_WAYLAND=1
```

## 其他的配置

### electron

为了 electron 专门添加的配置文件， `/.config/electron-flags.conf`

```
# file name: ~/.config/electron-flags.conf
--enable-features=UseOzonePlatform
--ozone-platform=wayland
```

按照行为来说，上述配置文件应该是所有版本的 electron 都会生效，但是对于旧一些的版本，比如 12 和 13，则需要添加单独的配置文件，但是由于配置内容相同，所以只需要分别建立软链接。

```
# pwd: ~/.config/
ln -s electron-flags.conf ~/.config/electron12-flags.conf
ln -s electron-flags.conf ~/.config/electron13-flags.conf
```

## 现存的大问题

electron 在 wayland 环境下不能使用 fcitx5，滚回 Xorg，第二次尝试迁移到 wayland 宣布失败。

## 参考

1. [ArchWiki](https://wiki.archlinux.org/title/Wayland#GUI_libraries)

